/*
* Copyright (C) 2015 German Aerospace Center (DLR/SC)
*
* Created: 2015-05-19 Martin Siggel <Martin.Siggel@dlr.de>
*
* Licensed under the Apache License, Version 2.0 (the "License");
* you may not use this file except in compliance with the License.
* You may obtain a copy of the License at
*
*     http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
*/

#ifndef CCPACSEXTERNALOBJECTS_H
#define CCPACSEXTERNALOBJECTS_H

#include "generated/CPACSGenericGeometryComponents.h"

namespace tigl
{
class CCPACSExternalObjects : public generated::CPACSGenericGeometryComponents
{
public:
    TIGL_EXPORT CCPACSExternalObjects(CCPACSAircraftModel* parent, CTiglUIDManager* uidMgr);

    TIGL_EXPORT CCPACSExternalObject& GetObject(int index) const;
    TIGL_EXPORT int GetObjectCount() const;
};

} //namespace tigl

#endif // CCPACSEXTERNALOBJECTS_H
