// Copyright (c) 2020 RISC Software GmbH
//
// This file was generated by CPACSGen from CPACS XML Schema (c) German Aerospace Center (DLR/SC).
// Do not edit, all changes are lost when files are re-generated.
//
// Licensed under the Apache License, Version 2.0 (the "License")
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#pragma once

#include <boost/optional.hpp>
#include <boost/utility/in_place_factory.hpp>
#include <string>
#include <tixi.h>
#include <typeinfo>
#include "CTiglError.h"
#include "CTiglUIDObject.h"
#include "tigl_internal.h"

namespace tigl
{
class CTiglUIDManager;
class CCPACSCrossBeamAssemblyPosition;
class CCPACSCrossBeamStrutAssemblyPosition;

namespace generated
{
    // This class is used in:
    // CPACSCrossBeamAssemblyPosition
    // CPACSCrossBeamStrutAssemblyPosition

    /// @brief alignmentCrossBeamType
    /// 
    /// 
    /// 
    class CPACSAlignmentCrossBeam : public CTiglReqUIDObject
    {
    public:
        TIGL_EXPORT CPACSAlignmentCrossBeam(CCPACSCrossBeamAssemblyPosition* parent, CTiglUIDManager* uidMgr);
        TIGL_EXPORT CPACSAlignmentCrossBeam(CCPACSCrossBeamStrutAssemblyPosition* parent, CTiglUIDManager* uidMgr);

        TIGL_EXPORT virtual ~CPACSAlignmentCrossBeam();

        template<typename P>
        bool IsParent() const
        {
            return m_parentType != NULL && *m_parentType == typeid(P);
        }

        template<typename P>
        P* GetParent()
        {
#ifdef HAVE_STDIS_SAME
            static_assert(std::is_same<P, CCPACSCrossBeamAssemblyPosition>::value || std::is_same<P, CCPACSCrossBeamStrutAssemblyPosition>::value, "template argument for P is not a parent class of CPACSAlignmentCrossBeam");
#endif
            if (!IsParent<P>()) {
                throw CTiglError("bad parent");
            }
            return static_cast<P*>(m_parent);
        }

        template<typename P>
        const P* GetParent() const
        {
#ifdef HAVE_STDIS_SAME
            static_assert(std::is_same<P, CCPACSCrossBeamAssemblyPosition>::value || std::is_same<P, CCPACSCrossBeamStrutAssemblyPosition>::value, "template argument for P is not a parent class of CPACSAlignmentCrossBeam");
#endif
            if (!IsParent<P>()) {
                throw CTiglError("bad parent");
            }
            return static_cast<P*>(m_parent);
        }

        TIGL_EXPORT virtual CTiglUIDObject* GetNextUIDParent();
        TIGL_EXPORT virtual const CTiglUIDObject* GetNextUIDParent() const;

        TIGL_EXPORT CTiglUIDManager& GetUIDManager();
        TIGL_EXPORT const CTiglUIDManager& GetUIDManager() const;

        TIGL_EXPORT virtual void ReadCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath);
        TIGL_EXPORT virtual void WriteCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath) const;

        TIGL_EXPORT virtual const std::string& GetUID() const;
        TIGL_EXPORT virtual void SetUID(const std::string& value);

        TIGL_EXPORT virtual const boost::optional<double>& GetOffset1LocX() const;
        TIGL_EXPORT virtual void SetOffset1LocX(const boost::optional<double>& value);

        TIGL_EXPORT virtual const boost::optional<double>& GetOffset2LocX() const;
        TIGL_EXPORT virtual void SetOffset2LocX(const boost::optional<double>& value);

        TIGL_EXPORT virtual const boost::optional<double>& GetRotationLocX() const;
        TIGL_EXPORT virtual void SetRotationLocX(const boost::optional<double>& value);

        TIGL_EXPORT virtual const boost::optional<double>& GetTranslationLocY() const;
        TIGL_EXPORT virtual void SetTranslationLocY(const boost::optional<double>& value);

        TIGL_EXPORT virtual const boost::optional<double>& GetTranslationLocZ() const;
        TIGL_EXPORT virtual void SetTranslationLocZ(const boost::optional<double>& value);

    protected:
        void* m_parent;
        const std::type_info* m_parentType;

        CTiglUIDManager* m_uidMgr;

        std::string             m_uID;

        /// Offset in direction of extrusion, first side
        /// (absolute value)
        boost::optional<double> m_offset1LocX;

        /// Offset in direction of extrusion, second side
        /// (absolute value)
        boost::optional<double> m_offset2LocX;

        /// Rotation around local x axis (extrusion axis)
        boost::optional<double> m_rotationLocX;

        /// Translation along local y axis (perpendicular
        /// to extrusion axis)
        boost::optional<double> m_translationLocY;

        /// Translation along local z axis (perpendicular
        /// to x ynd y axes)
        boost::optional<double> m_translationLocZ;

    private:
        CPACSAlignmentCrossBeam(const CPACSAlignmentCrossBeam&) = delete;
        CPACSAlignmentCrossBeam& operator=(const CPACSAlignmentCrossBeam&) = delete;

        CPACSAlignmentCrossBeam(CPACSAlignmentCrossBeam&&) = delete;
        CPACSAlignmentCrossBeam& operator=(CPACSAlignmentCrossBeam&&) = delete;
    };
} // namespace generated

// Aliases in tigl namespace
using CCPACSAlignmentCrossBeam = generated::CPACSAlignmentCrossBeam;
} // namespace tigl
