// Copyright (c) 2020 RISC Software GmbH
//
// This file was generated by CPACSGen from CPACS XML Schema (c) German Aerospace Center (DLR/SC).
// Do not edit, all changes are lost when files are re-generated.
//
// Licensed under the Apache License, Version 2.0 (the "License")
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#pragma once

#include <string>
#include <tixi.h>
#include <vector>
#include "tigl_internal.h"
#include "UniquePtr.h"

namespace tigl
{
class CTiglUIDManager;
class CTiglUIDObject;

namespace generated
{
    class CPACSControlSurfaceStep;
    class CPACSControlSurfacePath;

    // This class is used in:
    // CPACSControlSurfacePath

    /// @brief Definition of the steps of the control surface
    /// deflection path.
    /// 
    /// List of steps.
    /// 
    class CPACSControlSurfaceSteps
    {
    public:
        TIGL_EXPORT CPACSControlSurfaceSteps(CPACSControlSurfacePath* parent, CTiglUIDManager* uidMgr);

        TIGL_EXPORT virtual ~CPACSControlSurfaceSteps();

        TIGL_EXPORT CPACSControlSurfacePath* GetParent();

        TIGL_EXPORT const CPACSControlSurfacePath* GetParent() const;

        TIGL_EXPORT virtual CTiglUIDObject* GetNextUIDParent();
        TIGL_EXPORT virtual const CTiglUIDObject* GetNextUIDParent() const;

        TIGL_EXPORT CTiglUIDManager& GetUIDManager();
        TIGL_EXPORT const CTiglUIDManager& GetUIDManager() const;

        TIGL_EXPORT virtual void ReadCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath);
        TIGL_EXPORT virtual void WriteCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath) const;

        TIGL_EXPORT virtual const std::vector<std::unique_ptr<CPACSControlSurfaceStep>>& GetSteps() const;
        TIGL_EXPORT virtual std::vector<std::unique_ptr<CPACSControlSurfaceStep>>& GetSteps();

        TIGL_EXPORT virtual CPACSControlSurfaceStep& AddStep();
        TIGL_EXPORT virtual void RemoveStep(CPACSControlSurfaceStep& ref);

    protected:
        CPACSControlSurfacePath* m_parent;

        CTiglUIDManager* m_uidMgr;

        std::vector<std::unique_ptr<CPACSControlSurfaceStep>> m_steps;

    private:
        CPACSControlSurfaceSteps(const CPACSControlSurfaceSteps&) = delete;
        CPACSControlSurfaceSteps& operator=(const CPACSControlSurfaceSteps&) = delete;

        CPACSControlSurfaceSteps(CPACSControlSurfaceSteps&&) = delete;
        CPACSControlSurfaceSteps& operator=(CPACSControlSurfaceSteps&&) = delete;
    };
} // namespace generated

// Aliases in tigl namespace
using CCPACSControlSurfaceSteps = generated::CPACSControlSurfaceSteps;
using CCPACSControlSurfaceStep = generated::CPACSControlSurfaceStep;
using CCPACSControlSurfacePath = generated::CPACSControlSurfacePath;
} // namespace tigl
