// Copyright (c) 2020 RISC Software GmbH
//
// This file was generated by CPACSGen from CPACS XML Schema (c) German Aerospace Center (DLR/SC).
// Do not edit, all changes are lost when files are re-generated.
//
// Licensed under the Apache License, Version 2.0 (the "License")
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#pragma once

#include <string>
#include <tixi.h>
#include "tigl_internal.h"

namespace tigl
{
class CTiglUIDObject;

namespace generated
{
    class CPACSCutOutControlPoints;

    // This class is used in:
    // CPACSCutOutControlPoints

    /// @brief Additional definition of the leading edge cut out.
    /// 
    /// Optional. Definition of additional parameters,
    /// describing the shape of the parents leading edge of the cut out
    /// due to leading edge devices.
    /// The parameters are described in the picture below:
    /// @see led_cutout
    /// 
    class CPACSCutOutControlPoint
    {
    public:
        TIGL_EXPORT CPACSCutOutControlPoint(CPACSCutOutControlPoints* parent);

        TIGL_EXPORT virtual ~CPACSCutOutControlPoint();

        TIGL_EXPORT CPACSCutOutControlPoints* GetParent();

        TIGL_EXPORT const CPACSCutOutControlPoints* GetParent() const;

        TIGL_EXPORT virtual CTiglUIDObject* GetNextUIDParent();
        TIGL_EXPORT virtual const CTiglUIDObject* GetNextUIDParent() const;

        TIGL_EXPORT virtual void ReadCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath);
        TIGL_EXPORT virtual void WriteCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath) const;

        TIGL_EXPORT virtual const double& GetRelHeight() const;
        TIGL_EXPORT virtual void SetRelHeight(const double& value);

        TIGL_EXPORT virtual const double& GetXsi() const;
        TIGL_EXPORT virtual void SetXsi(const double& value);

    protected:
        CPACSCutOutControlPoints* m_parent;

        /// Relative height of the most forward position of
        /// the parents leading edge, relative to the airfoil height without
        /// cut out.
        double m_relHeight;

        /// Relative chordwise position of the most
        /// forward position of the parents leading edge, relative to the
        /// parents chord without cut out.
        double m_xsi;

    private:
        CPACSCutOutControlPoint(const CPACSCutOutControlPoint&) = delete;
        CPACSCutOutControlPoint& operator=(const CPACSCutOutControlPoint&) = delete;

        CPACSCutOutControlPoint(CPACSCutOutControlPoint&&) = delete;
        CPACSCutOutControlPoint& operator=(CPACSCutOutControlPoint&&) = delete;
    };
} // namespace generated

// Aliases in tigl namespace
using CCPACSCutOutControlPoint = generated::CPACSCutOutControlPoint;
using CCPACSCutOutControlPoints = generated::CPACSCutOutControlPoints;
} // namespace tigl
