// Copyright (c) 2020 RISC Software GmbH
//
// This file was generated by CPACSGen from CPACS XML Schema (c) German Aerospace Center (DLR/SC).
// Do not edit, all changes are lost when files are re-generated.
//
// Licensed under the Apache License, Version 2.0 (the "License")
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#pragma once

#include <string>
#include <tixi.h>
#include "CPACSCutOutControlPoint.h"
#include "tigl_internal.h"

namespace tigl
{
class CTiglUIDObject;
class CCPACSControlSurfaceWingCutOut;

namespace generated
{
    // This class is used in:
    // CPACSControlSurfaceWingCutOut

    /// @brief cutOutControlPointsType
    /// 
    /// 
    /// 
    class CPACSCutOutControlPoints
    {
    public:
        TIGL_EXPORT CPACSCutOutControlPoints(CCPACSControlSurfaceWingCutOut* parent);

        TIGL_EXPORT virtual ~CPACSCutOutControlPoints();

        TIGL_EXPORT CCPACSControlSurfaceWingCutOut* GetParent();

        TIGL_EXPORT const CCPACSControlSurfaceWingCutOut* GetParent() const;

        TIGL_EXPORT virtual CTiglUIDObject* GetNextUIDParent();
        TIGL_EXPORT virtual const CTiglUIDObject* GetNextUIDParent() const;

        TIGL_EXPORT virtual void ReadCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath);
        TIGL_EXPORT virtual void WriteCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath) const;

        TIGL_EXPORT virtual const CPACSCutOutControlPoint& GetInnerBorder() const;
        TIGL_EXPORT virtual CPACSCutOutControlPoint& GetInnerBorder();

        TIGL_EXPORT virtual const CPACSCutOutControlPoint& GetOuterBorder() const;
        TIGL_EXPORT virtual CPACSCutOutControlPoint& GetOuterBorder();

    protected:
        CCPACSControlSurfaceWingCutOut* m_parent;

        CPACSCutOutControlPoint m_innerBorder;
        CPACSCutOutControlPoint m_outerBorder;

    private:
        CPACSCutOutControlPoints(const CPACSCutOutControlPoints&) = delete;
        CPACSCutOutControlPoints& operator=(const CPACSCutOutControlPoints&) = delete;

        CPACSCutOutControlPoints(CPACSCutOutControlPoints&&) = delete;
        CPACSCutOutControlPoints& operator=(CPACSCutOutControlPoints&&) = delete;
    };
} // namespace generated

// Aliases in tigl namespace
using CCPACSCutOutControlPoints = generated::CPACSCutOutControlPoints;
} // namespace tigl
