// Copyright (c) 2020 RISC Software GmbH
//
// This file was generated by CPACSGen from CPACS XML Schema (c) German Aerospace Center (DLR/SC).
// Do not edit, all changes are lost when files are re-generated.
//
// Licensed under the Apache License, Version 2.0 (the "License")
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#pragma once

#include <string>
#include <tixi.h>
#include <vector>
#include "CPACSOuterCutOutProfile.h"
#include "tigl_internal.h"
#include "UniquePtr.h"

namespace tigl
{
class CTiglUIDManager;
class CTiglUIDObject;
class CCPACSControlSurfaceWingCutOut;

namespace generated
{
    class CPACSCutOutProfile;

    // This class is used in:
    // CPACSControlSurfaceWingCutOut

    /// @brief Definition of cut out profiles.
    /// 
    /// 
    /// 
    class CPACSCutOutProfiles
    {
    public:
        TIGL_EXPORT CPACSCutOutProfiles(CCPACSControlSurfaceWingCutOut* parent, CTiglUIDManager* uidMgr);

        TIGL_EXPORT virtual ~CPACSCutOutProfiles();

        TIGL_EXPORT CCPACSControlSurfaceWingCutOut* GetParent();

        TIGL_EXPORT const CCPACSControlSurfaceWingCutOut* GetParent() const;

        TIGL_EXPORT virtual CTiglUIDObject* GetNextUIDParent();
        TIGL_EXPORT virtual const CTiglUIDObject* GetNextUIDParent() const;

        TIGL_EXPORT CTiglUIDManager& GetUIDManager();
        TIGL_EXPORT const CTiglUIDManager& GetUIDManager() const;

        TIGL_EXPORT virtual void ReadCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath);
        TIGL_EXPORT virtual void WriteCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath) const;

        TIGL_EXPORT virtual const CPACSOuterCutOutProfile& GetOuterCutOutProfile() const;
        TIGL_EXPORT virtual CPACSOuterCutOutProfile& GetOuterCutOutProfile();

        TIGL_EXPORT virtual const CPACSOuterCutOutProfile& GetInnerCutOutProfile() const;
        TIGL_EXPORT virtual CPACSOuterCutOutProfile& GetInnerCutOutProfile();

        TIGL_EXPORT virtual const std::vector<std::unique_ptr<CPACSCutOutProfile>>& GetCutOutProfiles() const;
        TIGL_EXPORT virtual std::vector<std::unique_ptr<CPACSCutOutProfile>>& GetCutOutProfiles();

        TIGL_EXPORT virtual CPACSCutOutProfile& AddCutOutProfile();
        TIGL_EXPORT virtual void RemoveCutOutProfile(CPACSCutOutProfile& ref);

    protected:
        CCPACSControlSurfaceWingCutOut* m_parent;

        CTiglUIDManager* m_uidMgr;

        CPACSOuterCutOutProfile                          m_outerCutOutProfile;
        CPACSOuterCutOutProfile                          m_innerCutOutProfile;
        std::vector<std::unique_ptr<CPACSCutOutProfile>> m_cutOutProfiles;

    private:
        CPACSCutOutProfiles(const CPACSCutOutProfiles&) = delete;
        CPACSCutOutProfiles& operator=(const CPACSCutOutProfiles&) = delete;

        CPACSCutOutProfiles(CPACSCutOutProfiles&&) = delete;
        CPACSCutOutProfiles& operator=(CPACSCutOutProfiles&&) = delete;
    };
} // namespace generated

// Aliases in tigl namespace
using CCPACSCutOutProfiles = generated::CPACSCutOutProfiles;
using CCPACSCutOutProfile = generated::CPACSCutOutProfile;
} // namespace tigl
