// Copyright (c) 2020 RISC Software GmbH
//
// This file was generated by CPACSGen from CPACS XML Schema (c) German Aerospace Center (DLR/SC).
// Do not edit, all changes are lost when files are re-generated.
//
// Licensed under the Apache License, Version 2.0 (the "License")
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#pragma once

#include <boost/optional.hpp>
#include <boost/utility/in_place_factory.hpp>
#include <string>
#include <tixi.h>
#include "CTiglUIDObject.h"
#include "tigl_internal.h"

namespace tigl
{
class CTiglUIDManager;

namespace generated
{
    class CPACSDoorSurroundStructuresAssembly;

    // This class is used in:
    // CPACSDoorSurroundStructuresAssembly

    /// @brief doorSurroundStructurePositionType
    /// 
    /// DoorSurroundStructurePosition type, containing the position of a
    /// door surround structure
    /// 
    class CPACSDoorSurroundStructurePosition : public CTiglReqUIDObject
    {
    public:
        TIGL_EXPORT CPACSDoorSurroundStructurePosition(CPACSDoorSurroundStructuresAssembly* parent, CTiglUIDManager* uidMgr);

        TIGL_EXPORT virtual ~CPACSDoorSurroundStructurePosition();

        TIGL_EXPORT CPACSDoorSurroundStructuresAssembly* GetParent();

        TIGL_EXPORT const CPACSDoorSurroundStructuresAssembly* GetParent() const;

        TIGL_EXPORT virtual CTiglUIDObject* GetNextUIDParent();
        TIGL_EXPORT virtual const CTiglUIDObject* GetNextUIDParent() const;

        TIGL_EXPORT CTiglUIDManager& GetUIDManager();
        TIGL_EXPORT const CTiglUIDManager& GetUIDManager() const;

        TIGL_EXPORT virtual void ReadCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath);
        TIGL_EXPORT virtual void WriteCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath) const;

        TIGL_EXPORT virtual const std::string& GetUID() const;
        TIGL_EXPORT virtual void SetUID(const std::string& value);

        TIGL_EXPORT virtual const boost::optional<std::string>& GetName() const;
        TIGL_EXPORT virtual void SetName(const boost::optional<std::string>& value);

        TIGL_EXPORT virtual const boost::optional<std::string>& GetDescription() const;
        TIGL_EXPORT virtual void SetDescription(const boost::optional<std::string>& value);

        TIGL_EXPORT virtual const int& GetFramesGapFront() const;
        TIGL_EXPORT virtual void SetFramesGapFront(const int& value);

        TIGL_EXPORT virtual const int& GetFramesGapRear() const;
        TIGL_EXPORT virtual void SetFramesGapRear(const int& value);

        TIGL_EXPORT virtual const int& GetStringersGapPrimary() const;
        TIGL_EXPORT virtual void SetStringersGapPrimary(const int& value);

        TIGL_EXPORT virtual const int& GetStringersGapSecondary() const;
        TIGL_EXPORT virtual void SetStringersGapSecondary(const int& value);

    protected:
        CPACSDoorSurroundStructuresAssembly* m_parent;

        CTiglUIDManager* m_uidMgr;

        std::string                  m_uID;

        boost::optional<std::string> m_name;

        boost::optional<std::string> m_description;

        /// number of bays effected by DSS in front of
        /// door
        int                          m_framesGapFront;

        /// number of bays effected by DSS in behind of
        /// door
        int                          m_framesGapRear;

        /// number of bays effected by DSS
        int                          m_stringersGapPrimary;

        /// number of bays effected by DSS
        int                          m_stringersGapSecondary;

    private:
        CPACSDoorSurroundStructurePosition(const CPACSDoorSurroundStructurePosition&) = delete;
        CPACSDoorSurroundStructurePosition& operator=(const CPACSDoorSurroundStructurePosition&) = delete;

        CPACSDoorSurroundStructurePosition(CPACSDoorSurroundStructurePosition&&) = delete;
        CPACSDoorSurroundStructurePosition& operator=(CPACSDoorSurroundStructurePosition&&) = delete;
    };
} // namespace generated

// Aliases in tigl namespace
using CCPACSDoorSurroundStructurePosition = generated::CPACSDoorSurroundStructurePosition;
using CCPACSDoorSurroundStructuresAssembly = generated::CPACSDoorSurroundStructuresAssembly;
} // namespace tigl
