// Copyright (c) 2020 RISC Software GmbH
//
// This file was generated by CPACSGen from CPACS XML Schema (c) German Aerospace Center (DLR/SC).
// Do not edit, all changes are lost when files are re-generated.
//
// Licensed under the Apache License, Version 2.0 (the "License")
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#pragma once

#include <boost/optional.hpp>
#include <boost/utility/in_place_factory.hpp>
#include <string>
#include <tixi.h>
#include "CPACSEngineNacelle.h"
#include "CreateIfNotExists.h"
#include "CTiglUIDObject.h"
#include "tigl_internal.h"

namespace tigl
{
class CTiglUIDManager;
class CCPACSEngines;

namespace generated
{
    // This class is used in:
    // CPACSEngines

    /// @brief engineType
    /// 
    /// Engine type, containing engine data.
    /// 
    class CPACSEngine : public CTiglReqUIDObject
    {
    public:
        TIGL_EXPORT CPACSEngine(CCPACSEngines* parent, CTiglUIDManager* uidMgr);

        TIGL_EXPORT virtual ~CPACSEngine();

        TIGL_EXPORT CCPACSEngines* GetParent();

        TIGL_EXPORT const CCPACSEngines* GetParent() const;

        TIGL_EXPORT virtual CTiglUIDObject* GetNextUIDParent();
        TIGL_EXPORT virtual const CTiglUIDObject* GetNextUIDParent() const;

        TIGL_EXPORT CTiglUIDManager& GetUIDManager();
        TIGL_EXPORT const CTiglUIDManager& GetUIDManager() const;

        TIGL_EXPORT virtual void ReadCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath);
        TIGL_EXPORT virtual void WriteCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath) const;

        TIGL_EXPORT virtual const std::string& GetUID() const;
        TIGL_EXPORT virtual void SetUID(const std::string& value);

        TIGL_EXPORT virtual const std::string& GetName() const;
        TIGL_EXPORT virtual void SetName(const std::string& value);

        TIGL_EXPORT virtual const boost::optional<std::string>& GetDescription() const;
        TIGL_EXPORT virtual void SetDescription(const boost::optional<std::string>& value);

        TIGL_EXPORT virtual const boost::optional<double>& GetThrust00Scaling() const;
        TIGL_EXPORT virtual void SetThrust00Scaling(const boost::optional<double>& value);

        TIGL_EXPORT virtual const boost::optional<CPACSEngineNacelle>& GetNacelle() const;
        TIGL_EXPORT virtual boost::optional<CPACSEngineNacelle>& GetNacelle();

        TIGL_EXPORT virtual CPACSEngineNacelle& GetNacelle(CreateIfNotExistsTag);
        TIGL_EXPORT virtual void RemoveNacelle();

    protected:
        CCPACSEngines* m_parent;

        CTiglUIDManager* m_uidMgr;

        std::string                         m_uID;

        /// Name of engine
        std::string                         m_name;

        /// Description of engine
        boost::optional<std::string>        m_description;

        /// Scaling of engine take-off thrust
        boost::optional<double>             m_thrust00Scaling;

        boost::optional<CPACSEngineNacelle> m_nacelle;

    private:
        CPACSEngine(const CPACSEngine&) = delete;
        CPACSEngine& operator=(const CPACSEngine&) = delete;

        CPACSEngine(CPACSEngine&&) = delete;
        CPACSEngine& operator=(CPACSEngine&&) = delete;
    };
} // namespace generated

// Aliases in tigl namespace
using CCPACSEngine = generated::CPACSEngine;
} // namespace tigl
