// Copyright (c) 2020 RISC Software GmbH
//
// This file was generated by CPACSGen from CPACS XML Schema (c) German Aerospace Center (DLR/SC).
// Do not edit, all changes are lost when files are re-generated.
//
// Licensed under the Apache License, Version 2.0 (the "License")
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#pragma once

#include <string>
#include <tixi.h>
#include <vector>
#include "CTiglUIDObject.h"
#include "tigl_internal.h"
#include "UniquePtr.h"

namespace tigl
{
class CTiglUIDManager;
class CCPACSFuselageStringerFramePosition;
class CCPACSFramesAssembly;

namespace generated
{
    // This class is used in:
    // CPACSFramesAssembly

    /// @brief frameType
    /// 
    /// frame type, containing frame definition (V1.5+)
    /// 
    class CPACSFrame : public CTiglReqUIDObject
    {
    public:
        TIGL_EXPORT CPACSFrame(CCPACSFramesAssembly* parent, CTiglUIDManager* uidMgr);

        TIGL_EXPORT virtual ~CPACSFrame();

        TIGL_EXPORT CCPACSFramesAssembly* GetParent();

        TIGL_EXPORT const CCPACSFramesAssembly* GetParent() const;

        TIGL_EXPORT virtual CTiglUIDObject* GetNextUIDParent();
        TIGL_EXPORT virtual const CTiglUIDObject* GetNextUIDParent() const;

        TIGL_EXPORT CTiglUIDManager& GetUIDManager();
        TIGL_EXPORT const CTiglUIDManager& GetUIDManager() const;

        TIGL_EXPORT virtual void ReadCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath);
        TIGL_EXPORT virtual void WriteCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath) const;

        TIGL_EXPORT virtual const std::string& GetUID() const;
        TIGL_EXPORT virtual void SetUID(const std::string& value);

        TIGL_EXPORT virtual const std::vector<std::unique_ptr<CCPACSFuselageStringerFramePosition>>& GetFramePositions() const;
        TIGL_EXPORT virtual std::vector<std::unique_ptr<CCPACSFuselageStringerFramePosition>>& GetFramePositions();

        TIGL_EXPORT virtual CCPACSFuselageStringerFramePosition& AddFramePosition();
        TIGL_EXPORT virtual void RemoveFramePosition(CCPACSFuselageStringerFramePosition& ref);

    protected:
        CCPACSFramesAssembly* m_parent;

        CTiglUIDManager* m_uidMgr;

        std::string                                                       m_uID;
        std::vector<std::unique_ptr<CCPACSFuselageStringerFramePosition>> m_framePositions;

    private:
        CPACSFrame(const CPACSFrame&) = delete;
        CPACSFrame& operator=(const CPACSFrame&) = delete;

        CPACSFrame(CPACSFrame&&) = delete;
        CPACSFrame& operator=(CPACSFrame&&) = delete;
    };
} // namespace generated

// CPACSFrame is customized, use type CCPACSFrame directly
} // namespace tigl
