// Copyright (c) 2020 RISC Software GmbH
//
// This file was generated by CPACSGen from CPACS XML Schema (c) German Aerospace Center (DLR/SC).
// Do not edit, all changes are lost when files are re-generated.
//
// Licensed under the Apache License, Version 2.0 (the "License")
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#pragma once

#include <string>
#include <cctype>

#include "CTiglError.h"
#include "to_string.h"

namespace tigl
{
namespace generated
{
    // This enum is used in:
    // CPACSGenericSystem

    enum CPACSGenericSystem_geometricBaseType
    {
        cone,
        sphere,
        cube,
        cylinder
    };

    inline std::string CPACSGenericSystem_geometricBaseTypeToString(const CPACSGenericSystem_geometricBaseType& value)
    {
        switch(value) {
        case cone: return "cone";
        case sphere: return "sphere";
        case cube: return "cube";
        case cylinder: return "cylinder";
        default: throw CTiglError("Invalid enum value \"" + std_to_string(static_cast<int>(value)) + "\" for enum type CPACSGenericSystem_geometricBaseType");
        }
    }
    inline CPACSGenericSystem_geometricBaseType stringToCPACSGenericSystem_geometricBaseType(const std::string& value)
    {
        auto toLower = [](std::string str) { for (char& c : str) { c = std::tolower(c); } return str; };
        if (toLower(value) == "cone") { return cone; }
        if (toLower(value) == "sphere") { return sphere; }
        if (toLower(value) == "cube") { return cube; }
        if (toLower(value) == "cylinder") { return cylinder; }
        throw CTiglError("Invalid string value \"" + value + "\" for enum type CPACSGenericSystem_geometricBaseType");
    }
} // namespace generated

// Aliases in tigl namespace
using ECPACSGenericSystem_geometricBaseType = generated::CPACSGenericSystem_geometricBaseType;
} // namespace tigl
