// Copyright (c) 2020 RISC Software GmbH
//
// This file was generated by CPACSGen from CPACS XML Schema (c) German Aerospace Center (DLR/SC).
// Do not edit, all changes are lost when files are re-generated.
//
// Licensed under the Apache License, Version 2.0 (the "License")
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#pragma once

#include <CCPACSMaterialDefinition.h>
#include <string>
#include <tixi.h>
#include "CPACSLateralCap_placement.h"
#include "tigl_internal.h"

namespace tigl
{
class CTiglUIDManager;
class CTiglUIDObject;

namespace generated
{
    class CPACSStructuralWallElement;

    // This class is used in:
    // CPACSStructuralWallElement

    class CPACSLateralCap
    {
    public:
        TIGL_EXPORT CPACSLateralCap(CPACSStructuralWallElement* parent, CTiglUIDManager* uidMgr);

        TIGL_EXPORT virtual ~CPACSLateralCap();

        TIGL_EXPORT CPACSStructuralWallElement* GetParent();

        TIGL_EXPORT const CPACSStructuralWallElement* GetParent() const;

        TIGL_EXPORT virtual CTiglUIDObject* GetNextUIDParent();
        TIGL_EXPORT virtual const CTiglUIDObject* GetNextUIDParent() const;

        TIGL_EXPORT CTiglUIDManager& GetUIDManager();
        TIGL_EXPORT const CTiglUIDManager& GetUIDManager() const;

        TIGL_EXPORT virtual void ReadCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath);
        TIGL_EXPORT virtual void WriteCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath) const;

        TIGL_EXPORT virtual const double& GetArea() const;
        TIGL_EXPORT virtual void SetArea(const double& value);

        TIGL_EXPORT virtual const CCPACSMaterialDefinition& GetMaterial() const;
        TIGL_EXPORT virtual CCPACSMaterialDefinition& GetMaterial();

        TIGL_EXPORT virtual const CPACSLateralCap_placement& GetPlacement() const;
        TIGL_EXPORT virtual void SetPlacement(const CPACSLateralCap_placement& value);

    protected:
        CPACSStructuralWallElement* m_parent;

        CTiglUIDManager* m_uidMgr;

        /// Area of the cap.
        double                    m_area;

        /// Material properties.
        CCPACSMaterialDefinition  m_material;

        CPACSLateralCap_placement m_placement;

    private:
        CPACSLateralCap(const CPACSLateralCap&) = delete;
        CPACSLateralCap& operator=(const CPACSLateralCap&) = delete;

        CPACSLateralCap(CPACSLateralCap&&) = delete;
        CPACSLateralCap& operator=(CPACSLateralCap&&) = delete;
    };
} // namespace generated

// Aliases in tigl namespace
using CCPACSLateralCap = generated::CPACSLateralCap;
using CCPACSStructuralWallElement = generated::CPACSStructuralWallElement;
} // namespace tigl
