// Copyright (c) 2020 RISC Software GmbH
//
// This file was generated by CPACSGen from CPACS XML Schema (c) German Aerospace Center (DLR/SC).
// Do not edit, all changes are lost when files are re-generated.
//
// Licensed under the Apache License, Version 2.0 (the "License")
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#pragma once

#include <CCPACSStringVector.h>
#include <string>
#include <tixi.h>
#include "tigl_internal.h"

namespace tigl
{
class CTiglUIDObject;
class CCPACSNacelleProfile;

namespace generated
{
    // This class is used in:
    // CPACSProfileGeometry2D

    /// @brief List of 2D points, kept in two coordinate vecors (x, y)
    /// 
    /// This set of vectors contains an ordered list of points
    /// for x and y coordinates in the form of stringBased Vectors.
    /// The x and y vector elements with the same index specify a 2D
    /// point. The coordinates of the x vector of [0, 1].
    /// 
    class CPACSPointListXYVector
    {
    public:
        TIGL_EXPORT CPACSPointListXYVector(CCPACSNacelleProfile* parent);

        TIGL_EXPORT virtual ~CPACSPointListXYVector();

        TIGL_EXPORT CCPACSNacelleProfile* GetParent();

        TIGL_EXPORT const CCPACSNacelleProfile* GetParent() const;

        TIGL_EXPORT virtual CTiglUIDObject* GetNextUIDParent();
        TIGL_EXPORT virtual const CTiglUIDObject* GetNextUIDParent() const;

        TIGL_EXPORT virtual void ReadCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath);
        TIGL_EXPORT virtual void WriteCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath) const;

        TIGL_EXPORT virtual const CCPACSStringVector& GetX() const;
        TIGL_EXPORT virtual CCPACSStringVector& GetX();

        TIGL_EXPORT virtual const CCPACSStringVector& GetY() const;
        TIGL_EXPORT virtual CCPACSStringVector& GetY();

    protected:
        CCPACSNacelleProfile* m_parent;

        /// Vector of x coordinates
        CCPACSStringVector m_x;

        /// Vector of y coordinates
        CCPACSStringVector m_y;

    private:
        CPACSPointListXYVector(const CPACSPointListXYVector&) = delete;
        CPACSPointListXYVector& operator=(const CPACSPointListXYVector&) = delete;

        CPACSPointListXYVector(CPACSPointListXYVector&&) = delete;
        CPACSPointListXYVector& operator=(CPACSPointListXYVector&&) = delete;
    };
} // namespace generated

// CPACSPointListXYVector is customized, use type CCPACSPointListXYVector directly
} // namespace tigl
