// Copyright (c) 2020 RISC Software GmbH
//
// This file was generated by CPACSGen from CPACS XML Schema (c) German Aerospace Center (DLR/SC).
// Do not edit, all changes are lost when files are re-generated.
//
// Licensed under the Apache License, Version 2.0 (the "License")
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#pragma once

#include <boost/optional.hpp>
#include <boost/utility/in_place_factory.hpp>
#include <string>
#include <tixi.h>
#include "CTiglUIDObject.h"
#include "tigl_internal.h"

namespace tigl
{
class CTiglUIDManager;

namespace generated
{
    class CPACSControlSurfaceStep;

    // This class is used in:
    // CPACSControlSurfaceStep

    /// @brief pointXZType
    /// 
    /// Point type, containing an xz data doublet.
    /// 
    class CPACSPointXZ : public CTiglOptUIDObject
    {
    public:
        TIGL_EXPORT CPACSPointXZ(CPACSControlSurfaceStep* parent, CTiglUIDManager* uidMgr);

        TIGL_EXPORT virtual ~CPACSPointXZ();

        TIGL_EXPORT CPACSControlSurfaceStep* GetParent();

        TIGL_EXPORT const CPACSControlSurfaceStep* GetParent() const;

        TIGL_EXPORT virtual CTiglUIDObject* GetNextUIDParent();
        TIGL_EXPORT virtual const CTiglUIDObject* GetNextUIDParent() const;

        TIGL_EXPORT CTiglUIDManager& GetUIDManager();
        TIGL_EXPORT const CTiglUIDManager& GetUIDManager() const;

        TIGL_EXPORT virtual void ReadCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath);
        TIGL_EXPORT virtual void WriteCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath) const;

        TIGL_EXPORT virtual const boost::optional<std::string>& GetUID() const;
        TIGL_EXPORT virtual void SetUID(const boost::optional<std::string>& value);

        TIGL_EXPORT virtual const double& GetX() const;
        TIGL_EXPORT virtual void SetX(const double& value);

        TIGL_EXPORT virtual const double& GetZ() const;
        TIGL_EXPORT virtual void SetZ(const double& value);

    protected:
        CPACSControlSurfaceStep* m_parent;

        CTiglUIDManager* m_uidMgr;

        boost::optional<std::string> m_uID;

        /// X-Component
        double                       m_x;

        /// Z-Component
        double                       m_z;

    private:
        CPACSPointXZ(const CPACSPointXZ&) = delete;
        CPACSPointXZ& operator=(const CPACSPointXZ&) = delete;

        CPACSPointXZ(CPACSPointXZ&&) = delete;
        CPACSPointXZ& operator=(CPACSPointXZ&&) = delete;
    };
} // namespace generated

// Aliases in tigl namespace
using CCPACSPointXZ = generated::CPACSPointXZ;
using CCPACSControlSurfaceStep = generated::CPACSControlSurfaceStep;
} // namespace tigl
