// Copyright (c) 2020 RISC Software GmbH
//
// This file was generated by CPACSGen from CPACS XML Schema (c) German Aerospace Center (DLR/SC).
// Do not edit, all changes are lost when files are re-generated.
//
// Licensed under the Apache License, Version 2.0 (the "License")
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#pragma once

#include <string>
#include <tixi.h>
#include <vector>
#include "tigl_internal.h"
#include "UniquePtr.h"

namespace tigl
{
class CTiglUIDManager;
class CTiglUIDObject;
class CCPACSPressureBulkhead;

namespace generated
{
    class CPACSStructuralElements;

    // This class is used in:
    // CPACSStructuralElements

    /// @brief pressureBulkheadsType
    /// 
    /// PressureBulkheads type, conteining pressure bulkheads
    /// 
    class CPACSPressureBulkheads
    {
    public:
        TIGL_EXPORT CPACSPressureBulkheads(CPACSStructuralElements* parent, CTiglUIDManager* uidMgr);

        TIGL_EXPORT virtual ~CPACSPressureBulkheads();

        TIGL_EXPORT CPACSStructuralElements* GetParent();

        TIGL_EXPORT const CPACSStructuralElements* GetParent() const;

        TIGL_EXPORT virtual CTiglUIDObject* GetNextUIDParent();
        TIGL_EXPORT virtual const CTiglUIDObject* GetNextUIDParent() const;

        TIGL_EXPORT CTiglUIDManager& GetUIDManager();
        TIGL_EXPORT const CTiglUIDManager& GetUIDManager() const;

        TIGL_EXPORT virtual void ReadCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath);
        TIGL_EXPORT virtual void WriteCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath) const;

        TIGL_EXPORT virtual const std::vector<std::unique_ptr<CCPACSPressureBulkhead>>& GetPressureBulkheads() const;
        TIGL_EXPORT virtual std::vector<std::unique_ptr<CCPACSPressureBulkhead>>& GetPressureBulkheads();

        TIGL_EXPORT virtual CCPACSPressureBulkhead& AddPressureBulkhead();
        TIGL_EXPORT virtual void RemovePressureBulkhead(CCPACSPressureBulkhead& ref);

    protected:
        CPACSStructuralElements* m_parent;

        CTiglUIDManager* m_uidMgr;

        std::vector<std::unique_ptr<CCPACSPressureBulkhead>> m_pressureBulkheads;

    private:
        CPACSPressureBulkheads(const CPACSPressureBulkheads&) = delete;
        CPACSPressureBulkheads& operator=(const CPACSPressureBulkheads&) = delete;

        CPACSPressureBulkheads(CPACSPressureBulkheads&&) = delete;
        CPACSPressureBulkheads& operator=(CPACSPressureBulkheads&&) = delete;
    };
} // namespace generated

// CPACSPressureBulkheads is customized, use type CCPACSPressureBulkheads directly

// Aliases in tigl namespace
using CCPACSStructuralElements = generated::CPACSStructuralElements;
} // namespace tigl
