// Copyright (c) 2020 RISC Software GmbH
//
// This file was generated by CPACSGen from CPACS XML Schema (c) German Aerospace Center (DLR/SC).
// Do not edit, all changes are lost when files are re-generated.
//
// Licensed under the Apache License, Version 2.0 (the "License")
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#pragma once

#include <boost/optional.hpp>
#include <boost/utility/in_place_factory.hpp>
#include <CCPACSFuselageProfiles.h>
#include <CCPACSGuideCurveProfiles.h>
#include <CCPACSRotorProfiles.h>
#include <CCPACSStructuralProfiles.h>
#include <CCPACSWingProfiles.h>
#include <string>
#include <tixi.h>
#include "CPACSCurveProfiles.h"
#include "CPACSNacelleProfiles.h"
#include "CreateIfNotExists.h"
#include "tigl_internal.h"

namespace tigl
{
class CTiglUIDManager;
class CTiglUIDObject;

namespace generated
{
    class CPACSVehicles;

    // This class is used in:
    // CPACSVehicles

    /// @brief profilesType
    /// 
    /// Profiles type, containing profile geometries
    /// 
    class CPACSProfiles
    {
    public:
        TIGL_EXPORT CPACSProfiles(CPACSVehicles* parent, CTiglUIDManager* uidMgr);

        TIGL_EXPORT virtual ~CPACSProfiles();

        TIGL_EXPORT CPACSVehicles* GetParent();

        TIGL_EXPORT const CPACSVehicles* GetParent() const;

        TIGL_EXPORT virtual CTiglUIDObject* GetNextUIDParent();
        TIGL_EXPORT virtual const CTiglUIDObject* GetNextUIDParent() const;

        TIGL_EXPORT CTiglUIDManager& GetUIDManager();
        TIGL_EXPORT const CTiglUIDManager& GetUIDManager() const;

        TIGL_EXPORT virtual void ReadCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath);
        TIGL_EXPORT virtual void WriteCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath) const;

        TIGL_EXPORT virtual const boost::optional<CCPACSFuselageProfiles>& GetFuselageProfiles() const;
        TIGL_EXPORT virtual boost::optional<CCPACSFuselageProfiles>& GetFuselageProfiles();

        TIGL_EXPORT virtual const boost::optional<CCPACSWingProfiles>& GetWingAirfoils() const;
        TIGL_EXPORT virtual boost::optional<CCPACSWingProfiles>& GetWingAirfoils();

        TIGL_EXPORT virtual const boost::optional<CCPACSGuideCurveProfiles>& GetGuideCurves() const;
        TIGL_EXPORT virtual boost::optional<CCPACSGuideCurveProfiles>& GetGuideCurves();

        TIGL_EXPORT virtual const boost::optional<CCPACSRotorProfiles>& GetRotorAirfoils() const;
        TIGL_EXPORT virtual boost::optional<CCPACSRotorProfiles>& GetRotorAirfoils();

        TIGL_EXPORT virtual const boost::optional<CCPACSStructuralProfiles>& GetStructuralProfiles() const;
        TIGL_EXPORT virtual boost::optional<CCPACSStructuralProfiles>& GetStructuralProfiles();

        TIGL_EXPORT virtual const boost::optional<CPACSNacelleProfiles>& GetNacelleProfiles() const;
        TIGL_EXPORT virtual boost::optional<CPACSNacelleProfiles>& GetNacelleProfiles();

        TIGL_EXPORT virtual const boost::optional<CPACSCurveProfiles>& GetCurveProfiles() const;
        TIGL_EXPORT virtual boost::optional<CPACSCurveProfiles>& GetCurveProfiles();

        TIGL_EXPORT virtual CCPACSFuselageProfiles& GetFuselageProfiles(CreateIfNotExistsTag);
        TIGL_EXPORT virtual void RemoveFuselageProfiles();

        TIGL_EXPORT virtual CCPACSWingProfiles& GetWingAirfoils(CreateIfNotExistsTag);
        TIGL_EXPORT virtual void RemoveWingAirfoils();

        TIGL_EXPORT virtual CCPACSGuideCurveProfiles& GetGuideCurves(CreateIfNotExistsTag);
        TIGL_EXPORT virtual void RemoveGuideCurves();

        TIGL_EXPORT virtual CCPACSRotorProfiles& GetRotorAirfoils(CreateIfNotExistsTag);
        TIGL_EXPORT virtual void RemoveRotorAirfoils();

        TIGL_EXPORT virtual CCPACSStructuralProfiles& GetStructuralProfiles(CreateIfNotExistsTag);
        TIGL_EXPORT virtual void RemoveStructuralProfiles();

        TIGL_EXPORT virtual CPACSNacelleProfiles& GetNacelleProfiles(CreateIfNotExistsTag);
        TIGL_EXPORT virtual void RemoveNacelleProfiles();

        TIGL_EXPORT virtual CPACSCurveProfiles& GetCurveProfiles(CreateIfNotExistsTag);
        TIGL_EXPORT virtual void RemoveCurveProfiles();

    protected:
        CPACSVehicles* m_parent;

        CTiglUIDManager* m_uidMgr;

        boost::optional<CCPACSFuselageProfiles>   m_fuselageProfiles;
        boost::optional<CCPACSWingProfiles>       m_wingAirfoils;
        boost::optional<CCPACSGuideCurveProfiles> m_guideCurves;
        boost::optional<CCPACSRotorProfiles>      m_rotorAirfoils;
        boost::optional<CCPACSStructuralProfiles> m_structuralProfiles;
        boost::optional<CPACSNacelleProfiles>     m_nacelleProfiles;
        boost::optional<CPACSCurveProfiles>       m_curveProfiles;

    private:
        CPACSProfiles(const CPACSProfiles&) = delete;
        CPACSProfiles& operator=(const CPACSProfiles&) = delete;

        CPACSProfiles(CPACSProfiles&&) = delete;
        CPACSProfiles& operator=(CPACSProfiles&&) = delete;
    };
} // namespace generated

// CPACSProfiles is customized, use type CCPACSProfiles directly

// Aliases in tigl namespace
using CCPACSVehicles = generated::CPACSVehicles;
} // namespace tigl
