// Copyright (c) 2020 RISC Software GmbH
//
// This file was generated by CPACSGen from CPACS XML Schema (c) German Aerospace Center (DLR/SC).
// Do not edit, all changes are lost when files are re-generated.
//
// Licensed under the Apache License, Version 2.0 (the "License")
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#pragma once

#include <string>
#include <tixi.h>
#include <vector>
#include "tigl_internal.h"
#include "UniquePtr.h"

namespace tigl
{
class CTiglUIDManager;
class CTiglUIDObject;
class CCPACSRotorHinge;
class CCPACSRotorBladeAttachment;

namespace generated
{
    // This class is used in:
    // CPACSRotorBladeAttachment

    /// @brief rotorHubHingesType
    /// 
    /// RotorHubHinges type, defining hinges used to attach a
    /// rotor blade to the rotor head.
    /// 
    class CPACSRotorHubHinges
    {
    public:
        TIGL_EXPORT CPACSRotorHubHinges(CCPACSRotorBladeAttachment* parent, CTiglUIDManager* uidMgr);

        TIGL_EXPORT virtual ~CPACSRotorHubHinges();

        TIGL_EXPORT CCPACSRotorBladeAttachment* GetParent();

        TIGL_EXPORT const CCPACSRotorBladeAttachment* GetParent() const;

        TIGL_EXPORT virtual CTiglUIDObject* GetNextUIDParent();
        TIGL_EXPORT virtual const CTiglUIDObject* GetNextUIDParent() const;

        TIGL_EXPORT CTiglUIDManager& GetUIDManager();
        TIGL_EXPORT const CTiglUIDManager& GetUIDManager() const;

        TIGL_EXPORT virtual void ReadCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath);
        TIGL_EXPORT virtual void WriteCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath) const;

        TIGL_EXPORT virtual const std::vector<std::unique_ptr<CCPACSRotorHinge>>& GetHinges() const;
        TIGL_EXPORT virtual std::vector<std::unique_ptr<CCPACSRotorHinge>>& GetHinges();

        TIGL_EXPORT virtual CCPACSRotorHinge& AddHinge();
        TIGL_EXPORT virtual void RemoveHinge(CCPACSRotorHinge& ref);

    protected:
        CCPACSRotorBladeAttachment* m_parent;

        CTiglUIDManager* m_uidMgr;

        /// Definition of a flap, lead-lag or pitch hinge.
        std::vector<std::unique_ptr<CCPACSRotorHinge>> m_hinges;

    private:
        CPACSRotorHubHinges(const CPACSRotorHubHinges&) = delete;
        CPACSRotorHubHinges& operator=(const CPACSRotorHubHinges&) = delete;

        CPACSRotorHubHinges(CPACSRotorHubHinges&&) = delete;
        CPACSRotorHubHinges& operator=(CPACSRotorHubHinges&&) = delete;
    };
} // namespace generated

// CPACSRotorHubHinges is customized, use type CCPACSRotorHinges directly
} // namespace tigl
