// Copyright (c) 2020 RISC Software GmbH
//
// This file was generated by CPACSGen from CPACS XML Schema (c) German Aerospace Center (DLR/SC).
// Do not edit, all changes are lost when files are re-generated.
//
// Licensed under the Apache License, Version 2.0 (the "License")
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#pragma once

#include <string>
#include <tixi.h>
#include <vector>
#include "tigl_internal.h"
#include "UniquePtr.h"

namespace tigl
{
class CTiglUIDManager;
class CTiglUIDObject;

namespace generated
{
    class CPACSSheet;
    class CPACSStructuralProfile;

    // This class is used in:
    // CPACSStructuralProfile

    /// @brief List of sheets, connecting 2-dimensional profile
    /// points.
    /// 
    /// SheetList type, containing a list of sheets. Each sheet
    /// combines two points to one sheet.
    /// 
    class CPACSSheetList
    {
    public:
        TIGL_EXPORT CPACSSheetList(CPACSStructuralProfile* parent, CTiglUIDManager* uidMgr);

        TIGL_EXPORT virtual ~CPACSSheetList();

        TIGL_EXPORT CPACSStructuralProfile* GetParent();

        TIGL_EXPORT const CPACSStructuralProfile* GetParent() const;

        TIGL_EXPORT virtual CTiglUIDObject* GetNextUIDParent();
        TIGL_EXPORT virtual const CTiglUIDObject* GetNextUIDParent() const;

        TIGL_EXPORT CTiglUIDManager& GetUIDManager();
        TIGL_EXPORT const CTiglUIDManager& GetUIDManager() const;

        TIGL_EXPORT virtual void ReadCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath);
        TIGL_EXPORT virtual void WriteCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath) const;

        TIGL_EXPORT virtual const std::vector<std::unique_ptr<CPACSSheet>>& GetSheets() const;
        TIGL_EXPORT virtual std::vector<std::unique_ptr<CPACSSheet>>& GetSheets();

        TIGL_EXPORT virtual CPACSSheet& AddSheet();
        TIGL_EXPORT virtual void RemoveSheet(CPACSSheet& ref);

    protected:
        CPACSStructuralProfile* m_parent;

        CTiglUIDManager* m_uidMgr;

        std::vector<std::unique_ptr<CPACSSheet>> m_sheets;

    private:
        CPACSSheetList(const CPACSSheetList&) = delete;
        CPACSSheetList& operator=(const CPACSSheetList&) = delete;

        CPACSSheetList(CPACSSheetList&&) = delete;
        CPACSSheetList& operator=(CPACSSheetList&&) = delete;
    };
} // namespace generated

// CPACSSheetList is customized, use type CCPACSSheetList directly

// Aliases in tigl namespace
using CCPACSSheet = generated::CPACSSheet;
using CCPACSStructuralProfile = generated::CPACSStructuralProfile;
} // namespace tigl
