// Copyright (c) 2020 RISC Software GmbH
//
// This file was generated by CPACSGen from CPACS XML Schema (c) German Aerospace Center (DLR/SC).
// Do not edit, all changes are lost when files are re-generated.
//
// Licensed under the Apache License, Version 2.0 (the "License")
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#pragma once

#include <string>
#include <tixi.h>
#include "CPACSWallPositions.h"
#include "CPACSWallSegments.h"
#include "tigl_internal.h"

namespace tigl
{
class CTiglUIDManager;
class CTiglUIDObject;
class CCPACSFuselageStructure;

namespace generated
{
    // This class is used in:
    // CPACSFuselageStructure

    class CPACSWalls
    {
    public:
        TIGL_EXPORT CPACSWalls(CCPACSFuselageStructure* parent, CTiglUIDManager* uidMgr);

        TIGL_EXPORT virtual ~CPACSWalls();

        TIGL_EXPORT CCPACSFuselageStructure* GetParent();

        TIGL_EXPORT const CCPACSFuselageStructure* GetParent() const;

        TIGL_EXPORT virtual CTiglUIDObject* GetNextUIDParent();
        TIGL_EXPORT virtual const CTiglUIDObject* GetNextUIDParent() const;

        TIGL_EXPORT CTiglUIDManager& GetUIDManager();
        TIGL_EXPORT const CTiglUIDManager& GetUIDManager() const;

        TIGL_EXPORT virtual void ReadCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath);
        TIGL_EXPORT virtual void WriteCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath) const;

        TIGL_EXPORT virtual const CPACSWallPositions& GetWallPositions() const;
        TIGL_EXPORT virtual CPACSWallPositions& GetWallPositions();

        TIGL_EXPORT virtual const CPACSWallSegments& GetWallSegments() const;
        TIGL_EXPORT virtual CPACSWallSegments& GetWallSegments();

    protected:
        CCPACSFuselageStructure* m_parent;

        CTiglUIDManager* m_uidMgr;

        /// Definition of wall positions to place
        /// walls inside fuselage.
        CPACSWallPositions m_wallPositions;

        /// List of wall segments.
        CPACSWallSegments  m_wallSegments;

    private:
        CPACSWalls(const CPACSWalls&) = delete;
        CPACSWalls& operator=(const CPACSWalls&) = delete;

        CPACSWalls(CPACSWalls&&) = delete;
        CPACSWalls& operator=(CPACSWalls&&) = delete;
    };
} // namespace generated

// CPACSWalls is customized, use type CCPACSWalls directly
} // namespace tigl
