// Copyright (c) 2020 RISC Software GmbH
//
// This file was generated by CPACSGen from CPACS XML Schema (c) German Aerospace Center (DLR/SC).
// Do not edit, all changes are lost when files are re-generated.
//
// Licensed under the Apache License, Version 2.0 (the "License")
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#pragma once

#include <string>
#include <tixi.h>
#include <vector>
#include "tigl_internal.h"
#include "UniquePtr.h"

namespace tigl
{
class CTiglUIDManager;
class CTiglUIDObject;
class CCPACSWingRibsDefinition;
class CCPACSWingCSStructure;

namespace generated
{
    // This class is used in:
    // CPACSWingComponentSegmentStructure

    /// @brief Wing ribs
    /// 
    /// RibDefinitions type, containing the definition of all
    /// ribs of the wing.
    /// 
    class CPACSWingRibsDefinitions
    {
    public:
        TIGL_EXPORT CPACSWingRibsDefinitions(CCPACSWingCSStructure* parent, CTiglUIDManager* uidMgr);

        TIGL_EXPORT virtual ~CPACSWingRibsDefinitions();

        TIGL_EXPORT CCPACSWingCSStructure* GetParent();

        TIGL_EXPORT const CCPACSWingCSStructure* GetParent() const;

        TIGL_EXPORT virtual CTiglUIDObject* GetNextUIDParent();
        TIGL_EXPORT virtual const CTiglUIDObject* GetNextUIDParent() const;

        TIGL_EXPORT CTiglUIDManager& GetUIDManager();
        TIGL_EXPORT const CTiglUIDManager& GetUIDManager() const;

        TIGL_EXPORT virtual void ReadCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath);
        TIGL_EXPORT virtual void WriteCPACS(const TixiDocumentHandle& tixiHandle, const std::string& xpath) const;

        TIGL_EXPORT virtual const std::vector<std::unique_ptr<CCPACSWingRibsDefinition>>& GetRibsDefinitions() const;
        TIGL_EXPORT virtual std::vector<std::unique_ptr<CCPACSWingRibsDefinition>>& GetRibsDefinitions();

        TIGL_EXPORT virtual CCPACSWingRibsDefinition& AddRibsDefinition();
        TIGL_EXPORT virtual void RemoveRibsDefinition(CCPACSWingRibsDefinition& ref);

    protected:
        CCPACSWingCSStructure* m_parent;

        CTiglUIDManager* m_uidMgr;

        std::vector<std::unique_ptr<CCPACSWingRibsDefinition>> m_ribsDefinitions;

    private:
        CPACSWingRibsDefinitions(const CPACSWingRibsDefinitions&) = delete;
        CPACSWingRibsDefinitions& operator=(const CPACSWingRibsDefinitions&) = delete;

        CPACSWingRibsDefinitions(CPACSWingRibsDefinitions&&) = delete;
        CPACSWingRibsDefinitions& operator=(CPACSWingRibsDefinitions&&) = delete;
    };
} // namespace generated

// CPACSWingRibsDefinitions is customized, use type CCPACSWingRibsDefinitions directly
} // namespace tigl
