/*
* Copyright (C) 2015 German Aerospace Center (DLR/SC)
*
* Created: 2015-05-27 Martin Siggel <Martin.Siggel@dlr.de>
*
* Licensed under the Apache License, Version 2.0 (the "License");
* you may not use this file except in compliance with the License.
* You may obtain a copy of the License at
*
*     http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
*/

#ifndef ECPACSTRANSLATIONTYPE
#define ECPACSTRANSLATIONTYPE

#include "to_string.h"
#include "CTiglError.h"

namespace tigl
{
enum ECPACSTranslationType
{
    ABS_LOCAL,
    ABS_GLOBAL
};

inline std::string ECPACSTranslationTypeToString(const ECPACSTranslationType& value) {
    switch (value) {
        case ABS_LOCAL:  return "absLocal";
        case ABS_GLOBAL: return "absGlobal";
        default: throw CTiglError("Invalid enum value \"" + std_to_string(static_cast<int>(value)) + "\" for enum type ECPACSTranslationType");
    }
}

inline ECPACSTranslationType stringToECPACSTranslationType(const std::string& value) {
    if (value == "absLocal")  { return ABS_LOCAL;  }
    if (value == "absGlobal") { return ABS_GLOBAL; }
    throw CTiglError("Invalid string value \"" + value + "\" for enum type ECPACSTranslationType");
}

}

#endif // ECPACSTRANSLATIONTYPE

