/*
 * Copyright (C) 2007-2013 German Aerospace Center (DLR/SC)
 *
 * Created: 2013-01-31 Martin Siggel <martin.siggel@dlr.de>
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * @file   tigl_version.h
 * @brief  Definition of the tigl version numbers
 */

#ifndef TIGL_VERSION_H
#define TIGL_VERSION_H

/** @name Version Number
 *  Printable format: "%d.%d.%d", MAJOR, MINOR, PATCHLEVEL
 */
/*@{*/
#define TIGL_MAJOR_VERSION       3
#define TIGL_MINOR_VERSION       2
#define TIGL_PATCHLEVEL          3

#define TIGL_VERSION_STRING      "3.2.3"
#define TIGL_REVISION            ""

/** TIGL_VERSION_HEX returns a unique integer which is increasing with each release 
 *  This can be e.g. used in ifdefs
 */
#define TIGL_VERSION_HEX (TIGL_MAJOR_VERSION << 16 | TIGL_MINOR_VERSION << 8 | TIGL_PATCHLEVEL)
/*@}*/


#endif
